#include <cmath>
#include <iostream>
#include "RNP2to191.h"	//	乱数生成用クラス型 RNP2to191 が宣言されている

using namespace std;
using namespace rnp2to191;

RNP2to191 rn;			//	乱数生成用オブジェクト

int proposal( int icurrent ){
	if (rn.uni() < 0.5) return icurrent - 1;
	else                return icurrent + 1;
}

double TargetProb( int ipos ){
	if ((ipos < 1) || (ipos > 7)){
		return 0.0;
	}else{
		return ipos / 28.0;
	}
}

int main(){
	const int nsteps = 28000;
	int mcmc_pos[nsteps + 1];
	mcmc_pos[0] = 4;			//	初期値
	int count[] = { 0, 0, 0, 0, 0, 0, 0 };	//	各状態をとった回数の初期化
	for (int istep = 0; istep < nsteps; istep++){
		int proposed = proposal( mcmc_pos[istep] );
		double a = min( 1.0, TargetProb( proposed ) / TargetProb( mcmc_pos[istep] ) );
		if (rn.uni() < a){
			mcmc_pos[istep+1] = proposed;
		}else{
			mcmc_pos[istep+1] = mcmc_pos[istep];
		}
		count[mcmc_pos[istep+1]-1]++;
		cout << (istep+1) << ":";
		for (int i = 0; i < mcmc_pos[istep+1]; i++) 
			cout << "     ";
		cout << mcmc_pos[istep+1] << endl;
	}
	cout << endl;
	for (int i = 0; i < 7; i++){
		cout << "Position-" << (i+1) << ": p*28 = "
			<< (28.0 * count[i] / double(nsteps)) << "  I";
		for (int j = 0; j < count[i] / 300; j++)
			cout << "x";
		cout << endl;
	}
	cout << endl;
	return 0;
}
